#! /usr/bin/env node
const chalk = require('chalk')
const os = require('os')

function age() {
  const diff = new Date(Date.now() - new Date('09/06/2007'))
  return Math.abs(diff.getUTCFullYear() - 1970)
}

function sleep(ms) {
  return new Promise(resolve => setTimeout(resolve, ms))
}

function cleanLine(line) {
  return line.replaceAll(/\x1B\[[0-9]{2}m/g, '')
}

const info = [
  `${chalk.red('BluDood')} @ ${chalk.red(os.hostname())}`,
  '',
  `${chalk.red('Age')}: ${age()}`,
  `${chalk.red('Country')}: Norway`,
  '',
  `${chalk.red('Website')}: ${chalk.blue('https://bludood.com')}`,
  `${chalk.red('Email')}: ${chalk.blue('bludood@bludood.com')}`,
  `${chalk.red('GitHub')}: ${chalk.blue('https://github.com/BluDood')}`,
  `${chalk.red('Twitter')}: ${chalk.blue('https://twitter.com/ItsBluDood')}`,
  `${chalk.red('Discord')}: ${chalk.hex('#5865f2')('BluDood#0001')}`,
  `${chalk.red('Discord Server')}: ${chalk.blue('https://discord.bludood.com')}`,
  '',
  `${chalk.black('██')}${chalk.red('██')}${chalk.green('██')}${chalk.yellow('██')}${chalk.blue('██')}${chalk.magenta('██')}${chalk.cyan('██')}${chalk.white('██')}`,
  '',
  `Press any key to exit...`
]

const ascii = [
  '   .---::.              ..    ',
  '    .=+++++=-::::::::-=+:     ',
  '    =+#*******+:..:=****+====-',
  '    *%%#**++++##**##++++**#%%*',
  '    -%%%%%%####+..+#####%%%%%.',
  '    :*%%%%%%%%+.:::*%%%%%%%%+ ',
  '    :==+****+-.-+=-.-+****=.  ',
  '    :++=-----::::::::----     ',
  '   -====----------------.     ',
  '  =======--::::::::::::=.     ',
  ' -=++=======:..........=.     ',
  '.=++++======-::.....:::=.     ',
  ':=++++======-::::::::---      ',
  '-++=+++++++=----------:       ',
  '==++++++++==--------:         ',
  '===++++++++=======:           ',
  '==-:=++++++++==++:            ',
  '    =+++++:..==.              ',
  '       .==   -=.    ..        ',
  '   ..::::-:::::..:::.         '
]

function print(animate) {
  console.clear()
  const copy = [...ascii]
  const heightOffset = Math.floor((process.stdout.rows - copy.length) / 2)
  for (let i = 0; i < heightOffset; i++) {
    copy.push('')
    copy.unshift('')
  }
  copy.pop()
  const offset = Math.floor((copy.length - info.length) / 2)
  const lines = copy.map((a, i) => chalk.blue(a) + '  ' + (info[i - offset] || ''))
  const longestLine = [...lines.map(l => cleanLine(l))].sort((a, b) => b.length - a.length)[0].length
  const widthOffset = Math.floor((process.stdout.columns - longestLine) / 2)
  if (animate) {
    ;(async () => {
      for (const line of lines) {
        console.log(''.padStart(widthOffset, ' ') + line)
        await sleep(20)
      }
    })()
  } else console.log(lines.map(l => ''.padStart(widthOffset, ' ') + l).join('\n'))
}
print(true)
process.stdout.on('resize', () => print())

if (process.stdin.isTTY) process.stdin.setRawMode(true)
process.stdin.resume()
process.stdin.on('data', () => {
  console.clear()
  console.log(chalk.blue('Goodbye!'))
  process.exit()
})
